CombinedReloadingController (Apache Commons Configuration 2.15.1 API)
Description: declaration: package: org.apache.commons.configuration2.reloading, class: CombinedReloadingController

Package org.apache.commons.configuration2.reloading

# Class CombinedReloadingController

java.lang.Object
org.apache.commons.configuration2.reloading.ReloadingController
org.apache.commons.configuration2.reloading.CombinedReloadingController

All Implemented Interfaces:
  `EventSource`

public class CombinedReloadingController extends ReloadingController

A specialized `ReloadingController` implementation which manages an arbitrary number of other `ReloadingController` objects.

This class can be used to handle multiple simple controllers for reload operations as a single object. As a usage example consider a combined configuration containing a number of configuration sources of which some support reloading. In this scenario all `ReloadingController` instances for the reloading-enabled sources can be added to a `CombinedReloadingController`. Then by triggering the combined controller a reload check is performed on all child sources.

This class is a typical implementation of the composite pattern. An instance is constructed with a collection of sub `ReloadingController` objects. Its operations are implemented by delegating to all child controllers.

This class expects the managed controller objects to be passed to the constructor. From this list a defensive copy is created so that it cannot be changed later on. Derived classes can override the `getSubControllers()` method if they need another way to handle child controllers (for example a more dynamic way). However, they are then responsible to ensure a safe access to this list in a multi-threaded environment.

Since:
  2.0

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CombinedReloadingController(Collection<? extends ReloadingController> subCtrls)`
  Creates a new instance of `CombinedReloadingController` and initializes it with the `ReloadingController` objects to be managed.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ReloadingDetector`
  `getDetector()`
  Gets the `ReloadingDetector` used by this controller.
  `Collection<ReloadingController>`
  `getSubControllers()`
  Gets a (unmodifiable) collection with the sub controllers managed by this combined controller.
  `void`
  `resetInitialReloadingState()`
  Resets the reloading state of all managed sub controllers unconditionally.

  ### Methods inherited from class org.apache.commons.configuration2.reloading.ReloadingController

  `addEventListener, checkForReloading, isInReloadingState, removeEventListener, resetReloadingState`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### CombinedReloadingController

    public CombinedReloadingController(Collection<? extends ReloadingController> subCtrls)
    Creates a new instance of `CombinedReloadingController` and initializes it with the `ReloadingController` objects to be managed.
    Parameters:
      `subCtrls` - the collection with sub `ReloadingController`s (must not be null or contain null entries)
    Throws:
      `IllegalArgumentException` - if the passed in collection is null or contains null entries

- ## Method Details

  - ### getDetector

    public ReloadingDetector getDetector()
    Gets the `ReloadingDetector` used by this controller. This implementation returns a special reloading detector which operates on all managed controllers.
    Overrides:
      `getDetector` in class `ReloadingController`
    Returns:
      the `ReloadingDetector`

  - ### getSubControllers

    public Collection<ReloadingController> getSubControllers()
    Gets a (unmodifiable) collection with the sub controllers managed by this combined controller.
    Returns:
      a collection with sub controllers

  - ### resetInitialReloadingState

    public void resetInitialReloadingState()
    Resets the reloading state of all managed sub controllers unconditionally. This method is intended to be called after the creation of an instance. It may be the case that some of the sub controllers are already in reloading state, so their state is out of sync with this controller's global reloading state. This method ensures that the reloading state of all sub controllers is reset.